' %Z%%M%    %I%  %W%  %G%  %U%
' IBM Security Compliance Manager
' 5724-F82
' (C) IBM, 2006.
' All Rights Reserved
' Licensed Materials - Property of IBM
'
' US Government Users Restricted Rights - Use, duplication or
' disclosure restricted by GSA ADP Schedule Contract with IBM Corp.

Option Explicit

On Error Resume Next
Err.Clear

Const ScriptVersion = "1.0"
Const wbemFlagReturnImmediately = &h10
Const wbemFlagForwardOnly = &h20

Const ARG_PROCNAME = "PROC_NAME"
Const ARG_FILEPATH = "FILEPATH"
Const ARG_COMPUTER = "COMPUTER"

Dim colItems

Dim objWMIService
Dim objFile
Dim objItem
Dim errName

Dim argumentsNamed
Dim Arg
Dim Query
Dim ProcRunning
Dim ComputerName
Dim ProcessName
Dim FilePath 
Dim pos
Dim url

'-----------------------------------
ProcRunning = 0

If Not ParseArguments Then 
	UsageAndQuit
End If 

If (ProcessName <> "") Then
	errName="ProcessName"
	query = "SELECT Name FROM Win32_Process WHERE Name='" & ProcessName & "'"
	url = "winmgmts:\\" & ComputerName & "\root\CIMV2"
	Set objWMIService = GetObject(url)
  	Set colItems = objWMIService.ExecQuery(query, "WQL", wbemFlagReturnImmediately + wbemFlagForwardOnly)
	If (Not isNull(colItems)) then
		For Each objItem In colItems
			WScript.Echo "Value  = " & objItem.name
			ProcRunning = 1
		Next
	End if	
	If (ProcRunning = 0) Then
		WScript.Echo "INFO: The process is not running"
	End If
	ShowError
End If
  
If (FilePath <> "") Then
	errName="FilePath"
	Set objFile = WScript.CreateObject("Scripting.FileSystemObject")
	If objFile.FileExists(FilePath) then
		Wscript.Echo objFile.GetFileVersion(FilePath)
	Else
		WScript.Echo "ERROR: File [" & FilePath & "] does not exist"
	End If
	ShowError
End If
'-----------------------------------
Function ParseArguments
	ParseArguments = False
	ProcessName = ""
	FilePath = ""
	ComputerName = "."
  ' VBScript v5.1 does not support WScript.Arguments.Named
	If WScript.Version = "5.1" then
		errName="ParseArgs51"
		Set argumentsNamed = CreateObject ("Scripting.Dictionary")
		For Each arg in WScript.Arguments
			If Mid (arg, 1, 1) = "/" then
				pos = InStr (arg, ":")
				If pos > 0 Then
					argumentsNamed.Add UCase(Mid (arg, 2, pos - 2)), Mid (arg, pos + 1)
				Else
					argumentsNamed.Add UCase(Mid (arg, 2)), ""
				End If
			End If
		Next
		If argumentsNamed.Exists(ARG_PROCNAME) Then 
			ProcessName = argumentsNamed.Item(ARG_PROCNAME)
			ParseArguments = True
			If argumentsNamed.Exists(ARG_COMPUTER) Then
				ComputerName = argumentsNamed.Item(ARG_COMPUTER)
			End If
		End If
		If argumentsNamed.Exists(ARG_FILEPATH) Then
			FilePath = argumentsNamed.Item(ARG_FILEPATH)
			ParseArguments = True
		End If
	Else
		errName="ParseArgs"
		If WScript.Arguments.Named.Exists(ARG_PROCNAME)  Then 
			ProcessName = WScript.Arguments.Named(ARG_PROCNAME)
			ParseArguments = True
			If WScript.Arguments.Named.Exists(ARG_COMPUTER) Then
				computerName = WScript.Arguments.Named(ARG_COMPUTER)
			End If
		End If

		If WScript.Arguments.Named.Exists(ARG_FILEPATH) Then
			FilePath = WScript.Arguments.Named(ARG_FILEPATH)
			ParseArguments = True
		End If
	End If
	ShowError
End Function 
'-----------------------------------
Function UsageAndQuit
	WScript.StdErr.Write "Improper "
	ShowArguments
	WScript.StdErr.WriteLine "Usage: NavV2.vbs /" & ARG_PROCNAME & ":processName [/" & ARG_COMPUTER & ":value]"
	WScript.StdErr.WriteLine "OR"
	WScript.StdErr.WriteLine "Usage: NavV2.vbs /" & ARG_FILEPATH & ":path"
	WScript.Quit(1)
End Function 
'-----------------------------------
Function ShowError
	If Err.Number <> 0 Then
		Wscript.StdErr.WriteLine "-- " & errName & " --"
		Wscript.StdErr.WriteLine "Error: " & Err.Number & " (Hex " & Hex(Err.Number) & ")"
		Wscript.StdErr.WriteLine "Source: " &  Err.Source
		Wscript.StdErr.WriteLine "Description: " &  Err.Description
		WScript.StdErr.WriteLine "WSH version: " & WScript.Version
		WScript.StdErr.WriteLine "ScriptVersion: " & ScriptVersion
		ShowArguments
		errName=""
		Err.Clear
	End if 
End	Function
'-----------------------------------
Function ShowArguments
	WScript.StdErr.Write "Arguments: "
	For Each arg in WScript.Arguments 
		WScript.StdErr.Write arg & " "
	Next
	WScript.StdErr.WriteLine ""
End Function