' @(#)07    1.2  src/hc/client/collectors/C/vbs/PortInfo.vbs, hc.collectors.win, scmweb, 090914a  9/7/09  09:22:44
'
' IBM Security Compliance Manager
' 5724-F82
' (C) IBM, 2006.
' All Rights Reserved
' Licensed Materials - Property of IBM
'
' US Government Users Restricted Rights - Use, duplication or
' disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
'

On Error Resume Next

' Define Constants from the SDK and their associated string name
' Scope
Const NET_FW_SCOPE_ALL = 0
Const NET_FW_SCOPE_ALL_NAME = "ALL"
Const NET_FW_SCOPE_LOCAL_SUBNET = 1
Const NET_FW_SCOPE_LOCAL_SUBNET_NAME = "LOCAL_SUBNET"
Const NET_FW_SCOPE_CUSTOM = 2
Const NET_FW_SCOPE_CUSTOM_NAME = "CUSTOM"
Const NET_FW_SCOPE_UNKNOWN = "UNKNOWN"

' IP Version
Const NET_FW_IP_VERSION_V4 = 0
Const NET_FW_IP_VERSION_V4_NAME = "V4"
Const NET_FW_IP_VERSION_V6 = 1
Const NET_FW_IP_VERSION_V6_NAME = "V6"
Const NET_FW_IP_VERSION_ANY = 2
Const NET_FW_IP_VERSION_ANY_NAME = "ANY"
Const NET_FW_IP_VERSION_UNKNOWN = "UNKNOWN"

' Protocol
Const NET_FW_IP_PROTOCOL_TCP = 6
Const NET_FW_IP_PROTOCOL_TCP_NAME = "TCP"
Const NET_FW_IP_PROTOCOL_UDP = 17
Const NET_FW_IP_PROTOCOL_UDP_NAME = "UDP"
Const NET_FW_IP_PROTOCOL_UNKNOWN = "UNKNOWN"


Set objFirewall = CreateObject("HNetCfg.FwMgr")
If (Err.number <> 0) Then
  If IsNull(objFirewall)  Then
    WScript.StdErr.Write "[ERROR] HNetCfg.FwMgr not available."
  Else
    WScript.StdErr.Write "[ERROR] " & "HNetCfg.FwMgr " & Err.Number & " - " & Err.description
  End If
  WScript.Quit(-2)
End If

Set objPolicy0 = objFirewall.LocalPolicy
If (Err.number <> 0) Then
  If IsNull(objPolicy0)  Then
    WScript.StdErr.Write "[ERROR] Policy at HNetCfg.FwMgr not available."
  Else
    WScript.StdErr.Write "[ERROR] " & "Policy " & Err.Number & " - " & Err.description
  End If
  WScript.Quit(-3)
End If
Set objPolicy = objPolicy0.CurrentProfile
If (Err.number <> 0) Then
  If IsNull(objPolicy)  Then
    WScript.StdErr.Write "[ERROR] CurrentProfile at HNetCfg.FwMgr not available."
  Else
    WScript.StdErr.Write "[ERROR] " & "CurrentProfile " & Err.Number & " - " & Err.description
  End If
  WScript.Quit(-4)
End If

Set colPorts = objPolicy.GloballyOpenPorts
If (Err.number <> 0) Then
  If IsNull(colPorts)  Then
    WScript.StdErr.Write "[ERROR] GloballyOpenPorts property from HNetCfg.FwMgr not available."
  Else
    WScript.StdErr.Write "[ERROR] " & "GloballyOpenPorts " & Err.description
  End If
  WScript.Quit(-1)
End If

Dim msg
For Each objPort in colPorts
    Wscript.Echo "[port]"
    Wscript.Echo "port_name=" & objPort.Name
    Wscript.Echo "port_number=" & objPort.Port
    'Wscript.Echo "#Port enabled: " & objPort.Enabled
    If (objPort.Enabled = True) Then
      msg = "1"
    Else
      msg = "0"
    End If
    Wscript.Echo "enabled=" & msg
    'Wscript.Echo "#Port IP version: " & objPort.IPVersion
    
    ' Port protocol
    'Wscript.Echo "#Port protocol: " & objPort.Protocol
    Select Case objPort.Protocol
      Case NET_FW_IP_PROTOCOL_TCP msg = NET_FW_IP_PROTOCOL_TCP_NAME
      Case NET_FW_IP_PROTOCOL_UDP msg = NET_FW_IP_PROTOCOL_UDP_NAME
      Case Else msg = NET_FW_IP_PROTOCOL_UNKNOWN
    End Select
    Wscript.Echo "protocol=" & msg
    
    ' Port Scope
    'Wscript.Echo "#Port scope: " & objPort.Scope
    Select Case objPort.Scope
      Case NET_FW_SCOPE_ALL msg = NET_FW_SCOPE_ALL_NAME
      Case NET_FW_SCOPE_LOCAL_SUBNET msg = NET_FW_SCOPE_LOCAL_SUBNET_NAME
      Case NET_FW_SCOPE_CUSTOM msg = NET_FW_SCOPE_CUSTOM_NAME
      Case Else msg = NET_FW_SCOPE_UNKNOWN
    End Select
    Wscript.Echo "scope=" & msg
    
    ' IPVersion
    Select Case objPort.IpVersion
      Case NET_FW_IP_VERSION_V4 msg = NET_FW_IP_VERSION_V4_NAME
      Case NET_FW_IP_VERSION_V6 msg = NET_FW_IP_VERSION_V6_NAME
      Case NET_FW_IP_VERSION_ANY msg = NET_FW_IP_VERSION_ANY_NAME
      Case Else msg = NET_FW_IP_VERSION_UNKNOWN
    End Select
    Wscript.Echo "ip_version=" & msg
    
    ' If Builtin
    'Wscript.Echo "#Port built-in: " & objPort.Builtin
    If (objPort.Builtin = True) Then
      msg = "1"
    Else
      msg = "0"
    End If
    Wscript.Echo "builtin=" & msg
    
    'Wscript.Echo "#Port remote addresses: " & objPort.RemoteAddresses
    Wscript.Echo "remote_address=" & objPort.RemoteAddresses
    
    ' additional newline
    Wscript.Echo
Next
