' @(#)70  1.2  src/hc/client/collectors/C/vbs/sid.vbs, hc.collectors.win, scmweb, 080912a  9/12/06  03:50:59
'
' IBM Security Compliance Manager
' 5724-F82
' (C) IBM, 2005.
' All Rights Reserved
' Licensed Materials - Property of IBM
'
' US Government Users Restricted Rights - Use, duplication or
' disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
'
'------------------------------------------------------------
On Error Resume Next

machineSid = NULL
domainSid  = NULL

machineSid = getMachineSid("HKLM\SECURITY\SAM\Domains\Account\V")
If Err.number <> 0 Then
	WScript.StdErr.Write "[Error] Unable to read machine SID from registry (ERR:"& Err.Description &")."
	WScript.Quit(-1)
End If

domainSid  = getDomainSid

WScript.Echo "[SID]"
WScript.Echo "machine = " & machineSid
WScript.Echo "domain  = " & domainSid

WScript.Quit(0)


'------------------------------------------------------------
' Returns machine SID from Windows registry
'------------------------------------------------------------
Function getMachineSid(regkey)

	Set sh = Wscript.CreateObject("WScript.Shell")
	regValue = sh.RegRead(regkey)

	offset = UBound(regValue) - 24
	Dim cutSid(24)
	For i = 1 To 24
		cutSid(i) = regValue(i + offset)
	Next
	getMachineSid = ConvertSidToString(cutSid)

End Function


'------------------------------------------------------------
' Returns domain SID, if host belongs to domain, or empty
' string otherwise
'------------------------------------------------------------
Function getDomainSid
	Set root = GetObject("LDAP://rootDSE")
	If Not IsNull(root) Then
		Set domain = GetObject("LDAP://" & root.Get("defaultNamingContext") )
		domain.GetInfo
		getDomainSid = ConvertSidToString(domain.Get("objectSid"))
	Else
		getDomainSid = ""
	End If
	
End Function


'------------------------------------------------------------
' Converts SID from binary/variant array into string
'------------------------------------------------------------
' Pictorially the structure of an SID is as follows: 
'   1 1 1 1 1 1 
'   5 4 3 2 1 0 9 8 7 6 5 4 3 2 1 0 
' +---------------------------------+ 
' | SubAuthCount   |Re(SBZ)|  Rev   | 
' +---------------------------------+ 
' |     IdentifierAuthority[0]      | 
' +---------------------------------+ 
' |     IdentifierAuthority[1]      | 
' +---------------------------------+ 
' |     IdentifierAuthority[2]      | 
' +---------------------------------+ 
' |                                 | 
' + -  -  -  SubAuthority[]  -  - - + 
' |                                 | 
' +---------------------------------+
Function ConvertSidToString(sid) 

    revision = GetSidByte(sid, 1)
    subAuthCount = GetSidByte(sid, 2)

    Dim sidauth(5)
    For i = 0 To 5
        sidauth(i) = GetSidByte(sid, 3+i)
    Next
    If ( (sidauth(0) <> 0) OR (sidauth(1) <> 0) ) Then
        authority = "0x"
        For i = 0 To 5 
            authority = authority & Right("0" & Hex(Ascb(sidauth(i))), 1)
        Next       
       
    Else
        authority = CLng(sidauth(2)*(256^3) + sidauth(3)*(256^3) _
                         + sidauth(4)*(256^1) + sidauth(5))
    End If

    strSid = "S-" & revision & "-" & authority 
    c = 9
    For i = 1 To subAuthCount
        auth = 0
        For j = 0 To 3
            auth = auth + CLng(GetSidByte(sid, c))*(256^j)
            c = c + 1
        Next
        strSid = strSid & "-" & cstr(auth)
    Next
    ConvertSidToString = strSid
End Function


'------------------------------------------------------------
' Returns single byte/variant from sid object. Used to 
' handle two input SID formats: registry and active directory
'------------------------------------------------------------
Function GetSidByte(sid, index)
	If TypeName(sid) = "Byte()" Then
		GetSidByte = Ascb(Midb(sid, index, 1))
	Else
		GetSidByte = sid(index)
	End If
End Function

'------------------------------------------------------------